/**********************************************************************
  PPClCeBu߃Zbg V~[^
  $Id: main.c,v 1.7 2002/05/30 15:57:31 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"
#include "op_scemu.h"

#define	VERSION		"Ver 0.85 1999-2002"
#ifdef __human__
#define	PRATFORM	"X68k"
#else
#ifdef __CYGWIN__
#define	PRATFORM	"Cygwin"
#else
#define	PRATFORM	"AnyHost"
#endif
#endif

#define	FNAME_LENG	1024
#define	FILE_NUM	64

int  init_system() ;
void manprint() ;

int main(int argc,char *argv[])
{
  int           i,j ;
  unsigned char *workp ;
  unsigned char infname[FILE_NUM][FNAME_LENG] ;
  int           file_num ;
  
  file_num=0 ;
  simlog=NULL ;
  x_path = get_xpath( argv[0] ) ;
  
  for( i=1 ; i<argc ; i++ ){
    workp = argv[i] ;
    if( *workp == '-' ) {
      workp++ ;
      switch( *workp ){
      case 'h' :
      case 'H' :
      case '?' :
	manprint() ;
	exit(0) ;
	break ;
      case 'o' :
	i++ ;
	if( argc==i ) break ;
	j=strlen(argv[i]+1) ;
	simlog=malloc(j+1) ;
	strcpy(simlog,argv[i]) ;
	break ;
      }
    }else{
      workp = infname[file_num] ;
      for( j=0 ; j < FNAME_LENG ; j++ ) *workp++ = '\0' ; /*  */
      strcpy( infname[file_num++] , argv[i] ) ;
      if( file_num==FILE_NUM ){
	fprintf(stderr,"wt@Cő吔(=%d)𒴂܂\n",FILE_NUM) ;
	break ;
      }
    }
  }
  //setmode( fileno(stdout),O_BINARY ) ;

  if( init_system()!=NORMAL_EXIT ) exit(0) ;
      
  /*** shellN ***/
  if( file_num == 0 ){
    cmd_exec( "-\0" ) ;	/*** C^NeBu[h ***/
  }else{
    for( i=0 ; i<file_num ; i++ ){
      cmd_exec( infname[i] ) ;
    }
  }
  exit(0) ;
}

void manprint()
{
  printf("PPC Simulator for " PRATFORM " " VERSION " TANE\n");
  printf("Usage: ppcsim [-Options] [file....]\n");
  printf("  Options\n") ;
  printf("    -o log : V~[VbZ[Wt@Cɏo͂܂(default=stderr)\n");
  printf("    -h,?   : wv\\܂\n");
  printf("\n") ;
  printf("  filew肵Ȃꍇ̓C^NeBuVF[hɂȂ܂B\n") ;
}
