/**********************************************************************
  long long int printf
  $Id: printll.c,v 1.2 2002/04/29 03:39:14 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

#define BUFLEN 128

int printll(FILE *fp, long long int val, int len)
{
  int i,j ;
  unsigned char str[BUFLEN] ;

  for( i=0 ; i<BUFLEN ; i++ ){
    str[i]= '0' + (val%10) ;
    val /= 10 ;
    if( val==0 ) break ;
  }
  for( j=0 ; j<=len-i ; j++ ){
    fputc(' ',fp ) ;
  }
  for( j=i ; j>-1 ; j-- ){
    fputc(str[j],fp) ;
  }
  return(0) ;
}
      


