/**********************************************************************
  sarg̃Zbg
  $Id: sim_setarg.c,v 1.1.1.1 2002/01/13 14:59:54 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int	sim_setarg( struct MACHINE_RESOURCE *mres , struct TOKEN_STRUCT *tk_pt , int start )
{
int i ;
int arg_start ;
int arg_str_top ;
int len ;
int err ; 

 arg_start   = mres->mem_size[0] - ARG_START_OFFSET ;
 arg_str_top = mres->mem_size[0] - ARG_STR_TOP_OFFSET ;

 mres->GPR[3].rl=tk_pt->num - start ; /*** argc̐ݒ ***/
 mres->GPR[4].rl=arg_start          ; /*** argv̐ݒ ***/

 err=0 ;
 for( i=start ; i<tk_pt->num ; i++ ){
   if( mres->mem[seg(arg_start+0)]==NULL || 
       mres->mem_size[seg(arg_start+0)] < lad(arg_start+0) ){
     err=1 ; break ;
   }
   mres->mem[seg(arg_start+0)][lad(arg_start+0)]=(arg_str_top & 0xff000000)>>24 ;
   if( mres->mem[seg(arg_start+1)]==NULL || 
       mres->mem_size[seg(arg_start+1)] < lad(arg_start+1) ){
     err=1 ; break ;
   }
   mres->mem[seg(arg_start+1)][lad(arg_start+1)]=(arg_str_top & 0x00ff0000)>>16 ;
   if( mres->mem[seg(arg_start+2)]==NULL || 
       mres->mem_size[seg(arg_start+2)] < lad(arg_start+2) ){
     err=1 ; break ;
   }
   mres->mem[seg(arg_start+2)][lad(arg_start+2)]=(arg_str_top & 0x0000ff00)>> 8 ;
   if( mres->mem[seg(arg_start+3)]==NULL || 
       mres->mem_size[seg(arg_start+3)] < lad(arg_start+3) ){
     err=1 ; break ;
   }
   mres->mem[seg(arg_start+3)][lad(arg_start+3)]=(arg_str_top & 0x000000ff)     ;
   arg_start+=4 ;

   len = strlen( tk_pt->pt[i] ) ;
   strcpy( &mres->mem[seg(arg_str_top)][lad(arg_str_top)], tk_pt->pt[i] ) ;
   arg_str_top += len ;
   mres->mem[seg(arg_str_top)][lad(arg_str_top)]='\0' ;
   arg_str_top++ ;
 }

 if( err==0 ) return( NORMAL_EXIT ) ;
 else         return( MEM_ACCESS_FAULT ) ;
}

/*******************************************************************
  Segment=0 ̃Ԃ̍Ō4096bytearg̈ƂĎgp
  B
*******************************************************************/
