/**********************************************************************
  [v[uR}h
  $Id: prob_cmd.c,v 1.1 2002/04/29 03:39:14 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int prob_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
  int i ;

  if( tk_pt->pt[1]==NULL ){
    fprintf(simmsgfp,"---- memory probe ----\n") ;
    if( MemprobeBuf.num==0 ){
      fprintf(simmsgfp,"non probe point\n") ;
    }else{
      for( i=0 ; i<MemprobeBuf.num ; i++ ){
	fprintf(simmsgfp,"0x%08x\n",MemprobeBuf.adrs[i]) ;
      }
    }
    return(NORMAL_EXIT) ;
  }

  if( MemprobeBuf.num <= MEMPROBE_BUFSIZE ){
    MemprobeBuf.adrs[MemprobeBuf.num]=exatoi(tk_pt->pt[1]) ;
    MemprobeBuf.num++ ;
  }else{
    fprintf(simmsgfp,"probe point is full.\n") ;
  }

  return(NORMAL_EXIT) ;
}
